/* ************************************************* */
/*   			I 2 C   -  T o o l					 */
/*   Autoren  : Humer/Pregartner, 5AIH 2000/2001     */
/*   Version: 2.1   Jaenner 2003					 */
/* ************************************************* */


#include <reg517a.h>
#include <stdio.h>
#define WT 1

/* ************** Definition *********************** */
sbit SCL = P3^5;
sbit SDA = P3^4;



bit useDebug;

/* ************** Definition *********************** */
void wait ( int msec )
{
    char i;
    for( msec; msec != 0; msec --)
        for (i=0; i<83; i++ );
}


/* ************** Definition *********************** */
void i2c_debug( bit status )
{
    useDebug = status;
}

/* ************** Definition *********************** */
void i2c_start()
{
   SDA = 1;
   wait(WT);
   SCL = 1;
   wait(WT);
   SDA = 0;
   wait(WT);
   SCL = 0;
   wait(WT);
}
 
/* ************** Definition *********************** */    
void i2c_stop()
{
   unsigned char input_var;

   SCL = 1;
   wait(WT);
   SDA = 0;
   wait(WT);
   SCL = 1;
   wait(WT);
   SDA = 1;
   wait(WT);

   input_var = SDA;
}

/* ************** Definition *********************** */
unsigned char i2c_write( unsigned char sign )
{
   unsigned char i;
   unsigned char mask = 0x80;
   unsigned char ret;

   if (useDebug) printf("Write: ");
   for( i=0; i<8; i++)
   {   SDA = ((sign & mask) == mask) ? 1 : 0;
       if (useDebug) printf("%1d|", (int) (((sign & mask) == mask) ? 1 : 0) );
       mask >>= 1;
       wait(WT);
       SCL = 1;
       wait(WT);
       SCL = 0;
   }
   i = SDA;
   SDA = 1;
   SCL = 1;
   if (SDA == 0) if(useDebug) printf( "Acknowledge received\n");
   if (SDA == 1) if(useDebug) printf( "Acknowledge not received\n");
   ret = !SDA;
   wait(WT);
   SCL = 0;
   wait(WT);

   return ret;         // Rueckgabewert == 0 ... Acknowledge received
}

/* ************** Definition *********************** */
unsigned char i2c_exists( unsigned char adr )
{
   unsigned char ret=0;
   i2c_start();
   ret = i2c_write( adr );
   i2c_stop;
   return ret;
}

/* ************** Definition *********************** */
unsigned char i2c_read( int noack )
{
   unsigned char i;
   unsigned char mask = 0x80;
   unsigned char sign = 0x00;

   i = SDA;

   for (i=0; i<8; i++)
   {
       sign <<= 1;
       SCL = 1;
       wait(WT);
       sign |= SDA;
       SCL = 0;
       wait(WT);
   }

   if ( noack != 1 )  //ACK
   {
      SDA=0;               
      wait(WT);
      SCL=1;
      wait(WT);
      SCL=0;
   }

   return (sign);
}

