#include <reg517a.h>
#include <stdio.h>
#include "i2c.h"
#include "lcd.h"

void main()
{
   unsigned char hs, sec, min, hour;
   char temp[21];

   i2c_debug( 1 );

   i2c_start();
   i2c_write( 0xA0 );      // Adress
   i2c_write( 0x01 );      // set pointer to control status
   i2c_write( 0x00 );      // to hundreth of a second

   i2c_start();
   i2c_write( 0xA0 );      // Adress
   i2c_write( 0x02 );      // set pointer to control status
   i2c_write( 0x00 );      // to seconds

   i2c_start();
   i2c_write( 0xA0 );      // Adress
   i2c_write( 0x03 );      // set pointer to control status
   i2c_write( 0x29 );      // min

   i2c_start();
   i2c_write( 0xA0 );      // Adress
   i2c_write( 0x04 );      // set pointer to control status
   i2c_write( 0x12 );      // hour

   i2c_debug( 0 );
 
   init_lcd();
   blank_lcd();
  
   while(1)
   {
        i2c_start();
        i2c_write( 0xA0 );      // Address
        i2c_write( 0x01 );      // set data pointer
        i2c_start();
        i2c_write(0xA1);        // enable read mode
        hs = i2c_read(1);

        i2c_stop();
        i2c_start();
        i2c_write( 0xA0 );      // Address
        i2c_write( 0x02 );      // set data pointer
        i2c_start();
        i2c_write(0xA1);        // enable read mode
        sec = i2c_read(1);
        
        i2c_start();
        i2c_write( 0xA0 );      // Address
        i2c_write( 0x03 );      // set data pointer
        i2c_start();
        i2c_write(0xA1);        // enable read mode
        min  = i2c_read(1);

        i2c_start();
        i2c_write( 0xA0 );      // Address
        i2c_write( 0x04 );      // set data pointer
        i2c_start();
        i2c_write(0xA1);        // enable read mode
        hour = i2c_read(1);

        i2c_stop();

        hour = hour & 0x3F;

        sprintf( temp, "%02X:%02X:%02X:%02X", (int)hour, (int)min, (int)sec, (int)hs) ;
        print_lcd(1,1,temp);
        printf("%s\r",temp);

        wait(500);
   }
}
