/************************************************************************/
/*                            Uebung 17a                                */
/*                    Interruptgesteuerte Uhr                           */
/*                        mit I2C-Interrupt                             */
/************************************************************************/

/****   Steueranweisungen an den Compiler       ****/
#pragma iv(0x8000)
#pragma mod517
#pragma code debug pl(61)

/****   Angabe der Include Dateien              ****/
#include <reg517.h>
#include <stdio.h>
#include "lcd.h"

#define uchar unsigned char
#define uint unsigned int

/****   Globale Variblen                        ****/
bit secflag;
uchar stu, min, sec, msec;
char buffer[21];


void INTI2C (void) interrupt 2
{
       sec++;
       secflag = 1;
       
       if ( sec == 60 )
                {
                sec = 0;
                min++;
                }
       if ( min == 60 )
                {
                min = 0;
                stu++;
                }
       if ( stu == 24 ) stu = 0;
}


/****   Prototypen der Funktionen               ****/
void set_time (uchar stunde, uchar minute, uchar secunde, uchar msecunde);
void ini_ser0(void);
void ini_ser1(void);

/****   Funktionen                              ****/
void set_time (uchar stunde, uchar minute, uchar secunde, uchar msecunde)
{
        stu = stunde;
        min = minute;
        sec = secunde;
        msec = msecunde;
}

/************************************************************************/
/*      function ini_ser0 initialisiert serielle Schnittstelle 0        */
/************************************************************************/

void ini_ser0(void)
{
        data unsigned int OLD;

        S0CON = 0x72; /* Serieller Mode 1, 8bit, 1 Stopbit, TI0 gesetzt */
        BD = 1;                 /* Baudrate enable                      */
        OLD = PCON;             /* Baudrate 9600 bit                    */
        PCON = OLD | 0x80;      /* SMOD = 1                             */
}

/************************************************************************/
/*      function ini_ser1 initialisiert serielle Schnittstelle 1        */
/************************************************************************/

void ini_ser1(void)
{
        S1CON = 0xF2;   /* Serieller Mode B, 8bit, 1 Stopbit, TI0 gesetzt */
        S1REL = 0xD9;   /* Ladewert 217 fuer 9600 baud                  */
}

/************************************************************************/
/*                      Hauptprogramm                                   */
/************************************************************************/

main ()
{

EX1 = 1;                /**** Interrupt 1  enabled        ****/
EAL = 1;                /**** Interrupt allgemein erlaubt       ****/
IT1 = 1;                /* Flankensteuerung */

init_lcd();
blank_lcd();
ini_ser0();
ini_ser1();

set_time (20,30,0,0);

while (1)
        {
        
        while (!secflag);
        secflag = 0;
        printf ("%2u:%2u:%2u \n",(uint)stu,(uint)min,(uint)sec);
        sprintf(buffer,"Uhr mit I2C Interr.");
        print_lcd(1,1,buffer);
        sprintf (buffer,"%2u:%2u:%2u",(uint)stu,(uint)min,(uint)sec); 
        print_lcd(2,6,buffer);
        
        }

}

